require "class"

local RecipePopup = require "widgets/recipepopup"
local RecipePopup_Refresh_base=RecipePopup.Refresh or function() return "ERROR: Can't run RecipePopup_Refresh_base!" end

-- Create own instance of recipePopup class, so we can use it for our stuff
local MyRecipePopup = Class(RecipePopup, function(self, horizontal)
    -- Run RecipePopup contructor inside our widget
    RecipePopup._ctor(self,horizontal)
end)

function MyRecipePopup:Refresh()
    -- Don't refresh if no recipe is set
    if self.recipe~=nil then
        -- Refresh recipe widget
        RecipePopup_Refresh_base(self)
        -- Hide our custom menu background and description
        self.bg:Hide()
        self.desc:Hide()
        self.teaser:Hide()
		self.button:Hide()
        -- Move build button
        self.button:SetPosition(18,-35)
        -- Scale build button
        self.button:SetScale(0.5,0.5)
        -- tint build button
        self.button.image:SetTint(1,1,1,0.25)
        -- Loop ingredients, index and value
        local count_i=1
        for i,v in pairs(self.ing) do
            -- Get position of box
            local pos=v:GetPosition()
            -- Set new x
            pos.x=55*(i-1)
            -- Set new y
            pos.y=-30
            -- Set new position
            v:SetPosition(pos)
            -- Scale
            v:SetScale(0.8,0.8)
            -- Set bg tint
            v.bg:SetTint(1,1,1,0.25)
            -- Set ing tint
            v.ing:SetTint(1,1,1,0.55)
            -- Count
            count_i=count_i+1
        end

        -- Move recipe name to middle of ingredients boxes
        self.name:SetPosition((count_i-1)*56*0.35,20,0)
        -- Scale text
        self.name:SetScale(0.8,0.8)
        if self.skins_spinner~=nil then
            -- Move skins spinner
            self.skins_spinner:SetPosition(((count_i-1)*33*0.5)-4,-90,0)
            -- Scale skins spinner
            self.skins_spinner:SetScale(0,0)      
            -- Hide skinners BG
            self.spinner_bg:Hide()
            -- Hide skinners lines
            self.lines:Hide()                 
        end
    end
end

-- Load recipe
function MyRecipePopup:LoadRecipe(recipe, owner)
    -- Make sure recipe provided
    if recipe~=nil then
        -- Check if already losed this recipe, then hide it
        if self.recipe~=nil and self.recipe.name==recipe.name then
            -- Hide popup
            self:Hide()
            -- Set to nil, so it don't refresh
            self.recipe=nil
        else
            -- Show popup
            self:Show()
            -- Set recipe
            self:SetRecipe(recipe,owner)
        end
    end
end

-- Return class instance
return MyRecipePopup